#include <Xm/Xm.h>
#include <stdio.h>
#include "global.h"

void set_color(Widget widget, String fgcolor, String bgcolor, GC gc) {
  Display *dpy=XtDisplay(widget);
  Colormap cmap=DefaultColormapOfScreen(XtScreen(widget));
  XColor col, unused;

  if (fgcolor) {
    if (!XAllocNamedColor(dpy, cmap, fgcolor, &col, &unused)) {
      char buf[32];
      sprintf(buf, "Can't alloc %s", fgcolor);
      XtWarning(buf);
      return;
    }
    XSetForeground(dpy, gc, col.pixel);
  }

  if (bgcolor) {
    if (!XAllocNamedColor(dpy, cmap, bgcolor, &col, &unused)) {
      char buf[32];
      sprintf(buf, "Can't alloc %s", bgcolor);
      XtWarning(buf);
      return;
    }
    XSetBackground(dpy, gc, col.pixel);
  }
}
